program test_alphachannel;

global
  struct gfx[41]
    string name[13];
    int value;
  end = "SOLID"        , fx_solid,
        "SRC"          , fx_src,
        "DST"          , fx_dst,
        "SRC OVER DST" , fx_srcoverdst,
        "DST OVER SRC" , fx_dstoversrc,
        "SRC IN DST"   , fx_srcindst,
        "DST IN SRC"   , fx_dstinsrc,
        "SRC OUT DST"  , fx_srcoutdst,
        "DST OUT SRC"  , fx_dstoutsrc,
        "SRC ATOP DST" , fx_srcatopdst,
        "DST ATOP SRC" , fx_dstatopsrc,
        "SRC CLEAR DST", fx_srccleardst,
        "SRC XOR DST"  , fx_srcxordst,
        "ADDITIVE"     , fx_additiveblend,
        "SUBTRACTIVE"  , fx_subtractiveblend,
        "MULTIPLY"     , fx_multiplyblend,
        "AVERAGE"      , fx_averageblend,
        "SCREEN"       , fx_screenblend,
        "R"            , fx_rblend,
        "G"            , fx_gblend,
        "B"            , fx_bblend,
        "RG"           , fx_rgblend,
        "RB"           , fx_rbblend,
        "GB"           , fx_gbblend,
        "AND"          , fx_andblend,
        "OR"           , fx_orblend,
        "XOR"          , fx_xorblend,
        "INVERT"       , fx_invert,
				"RINVERT"      , fx_rinvert,
        "GINVERT"      , fx_ginvert,
        "BINVERT"      , fx_binvert,
        "RGINVERT"     , fx_rginvert,
        "RBINVERT"     , fx_rbinvert,
        "GBINVERT"     , fx_gbinvert,
        "GRAYSCALE"    , fx_grayscale,
        "RSCALE"       , fx_rscale,
        "GSCALE"       , fx_gscale,
        "BSCALE"       , fx_bscale,
        "RGSCALE"      , fx_rgscale,
        "RBSCALE"      , fx_rbscale,
        "GBSCALE"      , fx_gbscale,
				"TINT"         , fx_tint;
  fx_count;

  string rendering;
  string fx        = "SOLID";
  string fxc       = "0";
  string fxintens  = "128";

  size_value   = 100;
  angle_value  = 0;
  alpha_value  = 255;
  flags_value  = 0;
  fx_value     = 0;
  fx_color     = 0;
  fx_rgb       = 0;
  fx_r         = 128;
  fx_g         = 128;
  fx_b         = 128;
  fx_intensity = 128;
  
  c1, c2;

begin
  mode_set(640, 480, 32);

  map_load("background32.map");
  map_load("Gem-GemixStudio.map");

  screen_put(0, 1000);

  fnt_set_color(0, rgb(255, 255, 255), rgb(4, 4, 4), 0);

  write(0, 5,  10, 3, "RENDERING...: "); write(0, 84, 10, 3, rendering);
  write(0, 5,  20, 3, "FXMODE......: "); write(0, 84, 20, 3, fx);
  write(0, 5,  30, 3, "FXCOLOR.....: "); write(0, 84, 30, 3, fxc);
  write(0, 5,  40, 3, "FXINTENSITY.: "); write(0, 84, 40, 3, fxintens);
  write(0, 5,  50, 3, "FX R........: "); write_int(0, 84,  50, 3, &fx_r);
  write(0, 5,  60, 3, "FX G........: "); write_int(0, 84,  60, 3, &fx_g);
  write(0, 5,  70, 3, "FX B........: "); write_int(0, 84,  70, 3, &fx_b);
  write(0, 5,  80, 3, "ALPHA.......: "); write_int(0, 84,  80, 3, &alpha_value);
  write(0, 5,  90, 3, "FLAGS.......: "); write_int(0, 84,  90, 3, &flags_value);
  write(0, 5, 105, 3, "FPS.........: "); write_int(0, 84, 105, 3, &fps);

  if(mode_get_render(rendering2D_mode) == rendering2D_software)
    rendering = "SOFT";
  else
    rendering = "MMX";
  end

  Gem(1001);
           
  repeat
    if(key(_f1))  flags_value = 0;  end
    if(key(_f2))  flags_value = 1;  end
    if(key(_f3))  flags_value = 2;  end
    if(key(_f4))  flags_value = 3;  end

		if(key(_f5))  flags_value = 4;  end
    if(key(_f6))  flags_value = 5;  end
    if(key(_f7))  flags_value = 6;  end
    if(key(_f8))  flags_value = 7;  end

		if(key(_f9))  flags_value = 8;  end
    if(key(_f10)) flags_value = 9;  end
    if(key(_f11)) flags_value = 10; end
    if(key(_f12)) flags_value = 11; end

		if(key(_pgup) && fx_count < 41)
			fx_count++;
			fx       = gfx[fx_count].name;
			fx_value = gfx[fx_count].value;
			frame;
		end
		if(key(_pgdn) && fx_count > 0)
			fx_count--;
			fx       = gfx[fx_count].name;
			fx_value = gfx[fx_count].value;
			frame;
		end

		if(fx_count == 41)
			if(key(_l_shift) && key(_r) && fx_r >   0) fx_r--; end
			if(key(_r_shift) && key(_r) && fx_r < 255) fx_r++; end
			if(key(_l_shift) && key(_g) && fx_g >   0) fx_g--; end
			if(key(_r_shift) && key(_g) && fx_g < 255) fx_g++; end
			if(key(_l_shift) && key(_b) && fx_b >   0) fx_b--; end
			if(key(_r_shift) && key(_b) && fx_b < 255) fx_b++; end

			if(key(_l_control) && fx_intensity >   0) fx_intensity--; end
			if(key(_r_control) && fx_intensity < 255) fx_intensity++; end

			fxintens = itoa(fx_intensity);
			fx_color = rgb(fx_r, fx_g, fx_b);
			fxc      = itoa(fx_color);
		else
			fxc      = "0";
		end

		if(key(_c_plus)  && alpha_value < 255) alpha_value++; end
    if(key(_c_minus) && alpha_value >   0) alpha_value--; end

    if(key(_n)) set_fps(24, 0); end
    if(key(_m)) set_fps( 0, 0); end

    if(key(_a)) mode_set_render(rendering2D_mmx);      rendering = "MMX";  end
    if(key(_s)) mode_set_render(rendering2D_software); rendering = "SOFT"; end

    if(key(_f)) mode_change(mode_fullscreen); end
    if(key(_w)) mode_change(mode_window);     end

    frame;
  until(key(_esc));
  let_me_alone();
end

process Gem(graph)
begin
  x = 320;
  y = 240;

  loop
    flags       = flags_value;
    fxmode      = fx_value;
    fxcolor     = fx_color;
	  fxintensity = fx_intensity;
  	alpha       = alpha_value;

    frame;
  end
end
