program test_filters;

const
  bits = 16; // change to 8/16/32

global
  string s_filter_scale, s_filter_scanline;
  string rendering_type;
  int old_scalecount           = 0 , scalecount           = 0;
  int old_scanlinecount        = 0 , scanlinecount        = 0;
  int old_scanlinepercentcount = 25, scanlinepercentcount = 25;
  int old_fxcount              = 2 , fxcount              = 0;

  int scanlineflags;
  n;

begin
  mode_set(320, 240, bits, mode_window);

  map_load("malvado_background.map");

  screen_put(0, 1000);

  write(0, 160, 10, 4, "Test Filters");
  write(0, 5, 30, 3, "RENDERING......: "); write(0, 107, 30, 3, rendering_type);
  write(0, 5, 40, 3, "FILTER.SCALE...: "); write(0, 107, 40, 3, s_filter_scale);
  write(0, 5, 50, 3, "FILTER.SCANLINE: "); write(0, 107, 50, 3, s_filter_scanline);
  write(0, 5, 60, 3, "FPS............: "); write(0, 107, 60, 3, &fps);

  if(mode_get_render(rendering2D_mode) == rendering2D_software)
    rendering_type = "SOFT";
  else
    rendering_type = "MMX";
  end

  switch(mode_get_filter(filter_scaletype))
    case filter_scale_noscale:  s_filter_scale = "NOSCALE";  end
    case filter_scale_normal2x: s_filter_scale = "NORMAL2X"; end
    case filter_scale_scale2x:  s_filter_scale = "SCALE2X";  end
  end

  switch(mode_get_filter(filter_scanlinetype))
    case filter_scanline_noscanline:
      s_filter_scanline = "NOSCANLINE";
    end
    case filter_scanline_1x:
      switch(mode_get_filter(filter_scanlinepercent))
        case filter_scanline_25percent:  s_filter_scanline = "SCANLINE 1X 25%";  end
        case filter_scanline_50percent:  s_filter_scanline = "SCANLINE 1X 50%";  end
        case filter_scanline_75percent:  s_filter_scanline = "SCANLINE 1X 75%";  end
        case filter_scanline_100percent: s_filter_scanline = "SCANLINE 1X 100%"; end
      end
    end
  end

  repeat
    if(key(_n)) set_fps(24, 0); end
    if(key(_m)) set_fps( 0, 0); end

    if(key(_a)) mode_set_render(rendering2D_mmx);      rendering_type = "MMX";  end
    if(key(_s)) mode_set_render(rendering2D_software); rendering_type = "SOFT"; end

    if(key(_f)) mode_change(mode_fullscreen); end
    if(key(_w)) mode_change(mode_window);     end

    if(key(_pgup)  && scalecount           < filter_scale_scale2x)       scalecount++;               frame; end
    if(key(_pgdn)  && scalecount           > filter_scale_noscale)       scalecount--;               frame; end
    if(key(_up)    && scanlinecount        < filter_scanline_1x)         scanlinecount++;            frame; end
    if(key(_down)  && scanlinecount        > filter_scanline_noscanline) scanlinecount--;            frame; end
    if(key(_left)  && scanlinepercentcount > 25)                         scanlinepercentcount -= 25; frame; end
    if(key(_right) && scanlinepercentcount < 100)                        scanlinepercentcount += 25; frame; end

    if(scalecount           != old_scalecount    ||
       scanlinecount        != old_scanlinecount ||
       scanlinepercentcount != old_scanlinepercentcount)
      switch(scalecount)
        case filter_scale_noscale: // NOSCALE
          s_filter_scale = "NOSCALE";

          switch(scanlinecount)
            case filter_scanline_noscanline: // NOSCANLINE
              s_filter_scanline = "NOSCANLINE";

              scanlineflags = filter_scanline_noscanline;

              mode_set_filter(scalecount, scanlineflags, fxcount);
            end
            case filter_scanline_1x:         // SCANLINE 1X
              scanlineflags = filter_scanline_1x;

              switch(scanlinepercentcount)
                case 25:  s_filter_scanline = "SCANLINE 1X 25%";  scanlineflags |= filter_scanline_25percent;  end
                case 50:  s_filter_scanline = "SCANLINE 1X 50%";  scanlineflags |= filter_scanline_50percent;  end
                case 75:  s_filter_scanline = "SCANLINE 1X 75%";  scanlineflags |= filter_scanline_75percent;  end
                case 100: s_filter_scanline = "SCANLINE 1X 100%"; scanlineflags |= filter_scanline_100percent; end
              end

              mode_set_filter(scalecount, scanlineflags, fxcount);
            end
          end
        end
        case filter_scale_normal2x..filter_scale_scale2x: // NORMAL2X, SCALE2X
          if(scalecount == filter_scale_normal2x)
            s_filter_scale = "NORMAL2X";
          else
            s_filter_scale = "SCALE2X";
          end
          switch(scanlinecount)
            case filter_scanline_noscanline: // NOSCANLINE
              s_filter_scanline = "NOSCANLINE";

              scanlineflags = filter_scanline_noscanline;

              mode_set_filter(scalecount, scanlineflags, fxcount);
            end
            case filter_scanline_1x:         // SCANLINE 1X
              scanlineflags = filter_scanline_1x;

              switch(scanlinepercentcount)
                case 25:  s_filter_scanline = "SCANLINE 1X 25%";  scanlineflags |= filter_scanline_25percent;  end
                case 50:  s_filter_scanline = "SCANLINE 1X 50%";  scanlineflags |= filter_scanline_50percent;  end
                case 75:  s_filter_scanline = "SCANLINE 1X 75%";  scanlineflags |= filter_scanline_75percent;  end
                case 100: s_filter_scanline = "SCANLINE 1X 100%"; scanlineflags |= filter_scanline_100percent; end
              end

              mode_set_filter(scalecount, scanlineflags, fxcount);
            end
          end
        end
      end

      old_scalecount           = scalecount;
      old_scanlinecount        = scanlinecount;
      old_scanlinepercentcount = scanlinepercentcount;
      old_fxcount              = fxcount;
    end

    frame;
  until(key(_esc));
end