program Test_Video_Effects;
const
  mode_w = 640, mode_h = 480;
  mode_lenght = 6400;
  mode_bits   = 32; // use 16 or 32

global
  struct gfx[41]
    string name[13];
    int value;
  end = "SOLID"        , fx_solid,
        "SRC"          , fx_src,
        "DST"          , fx_dst,
        "SRC OVER DST" , fx_srcoverdst,
        "DST OVER SRC" , fx_dstoversrc,
        "SRC IN DST"   , fx_srcindst,
        "DST IN SRC"   , fx_dstinsrc,
        "SRC OUT DST"  , fx_srcoutdst,
        "DST OUT SRC"  , fx_dstoutsrc,
        "SRC ATOP DST" , fx_srcatopdst,
        "DST ATOP SRC" , fx_dstatopsrc,
        "SRC CLEAR DST", fx_srccleardst,
        "SRC XOR DST"  , fx_srcxordst,
        "ADDITIVE"     , fx_additiveblend,
        "SUBTRACTIVE"  , fx_subtractiveblend,
        "MULTIPLY"     , fx_multiplyblend,
        "AVERAGE"      , fx_averageblend,
        "SCREEN"       , fx_screenblend,
        "R"            , fx_rblend,
        "G"            , fx_gblend,
        "B"            , fx_bblend,
        "RG"           , fx_rgblend,
        "RB"           , fx_rbblend,
        "GB"           , fx_gbblend,
        "AND"          , fx_andblend,
        "OR"           , fx_orblend,
        "XOR"          , fx_xorblend,
        "INVERT"       , fx_invert,
				"RINVERT"      , fx_rinvert,
        "GINVERT"      , fx_ginvert,
        "BINVERT"      , fx_binvert,
        "RGINVERT"     , fx_rginvert,
        "RBINVERT"     , fx_rbinvert,
        "GBINVERT"     , fx_gbinvert,
        "GRAYSCALE"    , fx_grayscale,
        "RSCALE"       , fx_rscale,
        "GSCALE"       , fx_gscale,
        "BSCALE"       , fx_bscale,
        "RGSCALE"      , fx_rgscale,
        "RBSCALE"      , fx_rbscale,
        "GBSCALE"      , fx_gbscale,
				"TINT"         , fx_tint;
  fx_count;

  string rendering;
  string fx        = "SOLID";
  string fxc       = "RGBCHANNEL";
  string fxintens  = "128";

  count;

  alpha_value  = 255;
  fx_value     = 0;
  fx_color     = 0;
  fx_rgb       = 0;
  fx_r         = 128;
  fx_g         = 128;
  fx_b         = 128;
  fx_intensity = 128;
  flags_value  = 0;

begin
  // Sets video graphics mode
  mode_set(mode_w, mode_h, mode_bits);

  // Loads graphics' file
  fpg_load("test_effects" + itoa(mode_bits) + ".fpg");
  
  // Sets the number of frames per second
  set_fps(24, 0);

  // Puts background screen
  screen_put(0, 999);

  fnt_set_color(0, rgb(255, 255, 255), rgb(4, 4, 4), 0);

  write(0, 5,  10, 3, "GEMS........: "); write(0, 84, 10, 3, &count);
  write(0, 5,  20, 3, "RENDERING...: "); write(0, 84, 20, 3, rendering);
  write(0, 5,  30, 3, "FXMODE......: "); write(0, 84, 30, 3, fx);

  write(0, 5,  40, 3, "FXCOLOR.....: "); write(0, 84, 40, 3, fxc);
  write(0, 5,  50, 3, "FXINTENSITY.: "); write(0, 84, 50, 3, fxintens);
  write(0, 5,  60, 3, "FX R........: "); write(0, 84,  60, 3, &fx_r);
  write(0, 5,  70, 3, "FX G........: "); write(0, 84,  70, 3, &fx_g);
  write(0, 5,  80, 3, "FX B........: "); write(0, 84,  80, 3, &fx_b);
  write(0, 5,  90, 3, "ALPHA.......: "); write(0, 84,  90, 3, &alpha_value);
  write(0, 5, 100, 3, "FLAGS.......: "); write(0, 84, 100, 3, &flags_value);
  write(0, 5, 115, 3, "FPS.........: "); write(0, 84, 115, 3, &fps);

  write(0, 320, 30, 4, "Press space bar to create gems");


  if(mode_get_render(rendering2D_mode) == rendering2D_software)
    rendering = "SOFT";
  else
    rendering = "MMX";
  end

  repeat
  	// Each time the space key is pressed, a gem type
    // process is created
    if(key(_space)) gem(); count++; end
	  if(key(_enter)) signal(type gem, s_kill); count = 0; end

    if(key(_n)) set_fps(24, 0); end
    if(key(_m)) set_fps( 0, 0); end

    if(key(_s)) mode_set_render(rendering2D_software); rendering = "SOFT"; end
    if(key(_a)) mode_set_render(rendering2D_mmx);      rendering = "MMX";  end

    if(key(_f)) mode_change(mode_fullscreen); end
    if(key(_w)) mode_change(mode_window);     end

    if(key(_f1))  flags_value = 0;  end
    if(key(_f2))  flags_value = 1;  end
    if(key(_f3))  flags_value = 2;  end
    if(key(_f4))  flags_value = 3;  end

	  if(key(_f5))  flags_value = 4;  end
    if(key(_f6))  flags_value = 5;  end
    if(key(_f7))  flags_value = 6;  end
    if(key(_f8))  flags_value = 7;  end

  	if(key(_f9))  flags_value = 8;  end
    if(key(_f10)) flags_value = 9;  end
    if(key(_f11)) flags_value = 10; end
    if(key(_f12)) flags_value = 11; end

    if(key(_c_plus)  && alpha_value < 255) alpha_value++; end
    if(key(_c_minus) && alpha_value >   0) alpha_value--; end

	  if(key(_pgup) && fx_count < 41)
	    fx_count++;
  	  fx       = gfx[fx_count].name;
	    fx_value = gfx[fx_count].value;
	    frame;
  	end
	  if(key(_pgdn) && fx_count > 0)
	    fx_count--;
  	  fx       = gfx[fx_count].name;
	    fx_value = gfx[fx_count].value;
	    frame;
  	end

	  if(fx_count == 41)
	    if(key(_l_shift) && key(_r) && fx_r >   0) fx_r--; end
  	  if(key(_r_shift) && key(_r) && fx_r < 255) fx_r++; end
	    if(key(_l_shift) && key(_g) && fx_g >   0) fx_g--; end
	    if(key(_r_shift) && key(_g) && fx_g < 255) fx_g++; end
  	  if(key(_l_shift) && key(_b) && fx_b >   0) fx_b--; end
	    if(key(_r_shift) && key(_b) && fx_b < 255) fx_b++; end

	    if(key(_l_control) && fx_intensity >   0) fx_intensity--; end
  	  if(key(_r_control) && fx_intensity < 255) fx_intensity++; end

	    fxintens = itoa(fx_intensity);
	    fx_color = rgb(fx_r, fx_g, fx_b);
  	  fxc      = itoa(fx_color);
	  else
	    fxc      = "0";
  	end

    frame;
  until(key(_esc))
  let_me_alone();
end

//--------------------------------------------------------------------
// Process gem
// Handles gem's animations
//--------------------------------------------------------------------
process gem()
private
  velocity_x;         // Horizontal coordinate increment
  velocity_y;         // Vertical coordinate increment
  initial_velocity_y; // Bounce length

begin
  // Creates process on left middle side
  x=0; y=4600;
  resolution=10;  // Forces coordinates to use one decimal
  // Initiates horizontal increment from 1 to 8 points
  velocity_x=rand(10,80);
  // Reinitiates initial bounce length from 8 to 25 points
  initial_velocity_y=rand(-80,-250);
  // Vertical increment equals bounce length
  velocity_y=initial_velocity_y;
  // Creates an endless loop
  loop
    // Creates a loop that goes over every single image
    // that composes the animation, which ranges from code numbers 1 to 16
    from graph=1 to 16;
			flags       = flags_value;
			fxmode      = fx_value;
			fxcolor     = fx_color;
			fxintensity = fx_intensity;
			alpha       = alpha_value;

      // Moves process horizontally
      x=x+velocity_x;
      // If either side of screen is reached
      if(x<0 or x>mode_lenght)
        // Changes increment sign, so does
        // with movement direction
        velocity_x=-velocity_x;
      end
      // Moves process vertically
      y=y+velocity_y;
      // If bounce height has reached it's limit
      if(-velocity_y<=initial_velocity_y)
        // Reinitiates length to the initial one
        velocity_y=-velocity_y;
      else
        // Decreases increment on bounce length
        velocity_y=velocity_y+7;
      end

      frame;  // Shows process on screen
    end
  end
end